#include "matrix.hpp"

int main() {
  vector a = vector(2);
  a[0] = 1;
  a[1] = 1;

  vector b = vector(2);
  b[0] = 1;
  b[1] = cnumber(1, 0);

  vector c = vector(2);
  c[0] = 2;
  c[1] = cnumber(1, 1);

  vector d = vector(2);
  d[0] = cnumber(1, -1);
  d[1] = 5;

  matrix m = matrix(2, 2);
  m[0] = a;
  m[1] = b;

  matrix n = matrix(2, 2);
  n[0] = c;
  n[1] = d;

  cout << "The matrix m" << endl;
  cout << m << endl;
  cout << "The determinant of matrix m:" << endl;
  cout << m.determinant() << endl;
  cout << "The matrix n:" << endl;
  cout << n << endl;
  cout << "The matrix n roted by one pi radian:" << endl;
  cout << n.rotate_by_one_pi() << endl;
  cout << "The determinant of matrix n:" << endl;
  cout << n.determinant() << endl;
  cout << "The matrix n's transpose:" << endl;
  cout << n.transpose() << endl;
  cout << "The matrix n's diagonal:" << endl;
  cout << n.get_diagonal() << endl;
  cout << "The matrix n's off diagonal:" << endl;
  cout << n.get_off_diagonal() << endl;
  cout << "The matrix m * n" << endl;
  cout << m * n << endl;
  cout << "The matrix m + n" << endl;
  cout << m + n << endl;
  cout << "Is 2 an eigenvalue of m?" << endl;
  if (m.is_eigenvalue(2)) {
    cout << "Yes!" << endl;
  } else {
    cout << "No!" << endl;
  }
  if (n.is_hermitian()) {
    cout << "The matrix n is hermitian, here is the hermitian conjugate:"
         << endl;
    cout << n.hermitian_conjugate() << endl;
  }
  return 0;
}
